(document:surround "/std/frame")

;;; Vars

;;; UI
(document:id form (vbox margin 10 align "top" activity #f
    (groupbox title (_ "kiosk mode")
        (vbox align "top"
            (checkbox name "kiosk_mode" text (_ "enabled"))
            (gridbox columns "50;50" align "top"
                (label text (_ "Profiles: "))
                (label text (_ "Profile content: "))

                (document:id profiles (checktree (when selected (profiles-change))))
                (listbox name "profile_content")
            )
        )
    )

    (hbox align "left"
        (button text (_ "Apply") align "left" (when clicked (act-save)))
        (button text (_ "Reset") align "left" (when clicked (act-reset)))
    )
))

;;; Logic
(define (act-save)
    (woo-write "/kiosk/save" 
        'profile_name (profiles current-rows)
        'kiosk_mode (cadr (assq (form-value "kiosk_mode") '((#t 1) (#f 0))))
    )
)

(define (fill-profiles profile_list)
    (profiles (rows-clear))
    (for-each 
        (lambda (x) (profiles append-row (string-append (woo-get-option x 'name) ";;" (woo-get-option x 'name))))
        profile_list
    )
)

(define (act-reset)
    (catch/message
      (lambda()
        (fill-profiles (woo-list "/kiosk/profiles"))
        (form-update-value "kiosk_mode" (woo-get-option (woo-read-first "/kiosk") 'kiosk_mode))
        (profiles current-rows (woo-get-option (woo-read-first "/kiosk") 'profiles_enabled))
	(form activity #t)))
)

(define (profiles-change)
    (form-update-enum "profile_content" (woo-list "/kiosk/profile_content" 'profile_name (profiles current)))
)

(document:root
    (when loaded
        (act-reset)
    )
)
